Index: LinearAlgebra/src/LinearAlgebra/BoxVector.hpp
===================================================================
--- LinearAlgebra/src/LinearAlgebra/BoxVector.hpp	(revision de29ad6ec3f6c4826f398de6a82efb8324c26e79)
+++ LinearAlgebra/src/LinearAlgebra/BoxVector.hpp	(revision 68c92366449b96cba16e719bf1bc16ca92f66370)
@@ -27,5 +27,5 @@
 public:
   BoxVector();
-  ~BoxVector();
+  virtual ~BoxVector();
 };
 
Index: LinearAlgebra/src/unittests/MatrixContentUnitTest.cpp
===================================================================
--- LinearAlgebra/src/unittests/MatrixContentUnitTest.cpp	(revision de29ad6ec3f6c4826f398de6a82efb8324c26e79)
+++ LinearAlgebra/src/unittests/MatrixContentUnitTest.cpp	(revision 68c92366449b96cba16e719bf1bc16ca92f66370)
@@ -193,4 +193,5 @@
         default:
           CPPUNIT_ASSERT_EQUAL( -1., m->at(i,j) );
+          break;
       }
   // check that op is reversable
@@ -227,4 +228,5 @@
         default:
           CPPUNIT_ASSERT_EQUAL( -1., m->at(i,j) );
+          break;
       }
   // check that op is reversable
Index: src/Actions/MoleculeAction/FillWithMoleculeAction.cpp
===================================================================
--- src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision de29ad6ec3f6c4826f398de6a82efb8324c26e79)
+++ src/Actions/MoleculeAction/FillWithMoleculeAction.cpp	(revision 68c92366449b96cba16e719bf1bc16ca92f66370)
@@ -68,5 +68,5 @@
   molecule *filler = World::getInstance().getMolecule(MoleculeByOrder(-1)); // get last molecule
   filler->SetNameFromFilename(params.fillername.string().c_str());
-  molecule *Filling = NULL;
+//    molecule *Filling = NULL;
 //    atom *first = NULL, *second = NULL, *third = NULL;
 //    first = World::getInstance().createAtom();
Index: src/Actions/WorldAction/CenterInBoxAction.cpp
===================================================================
--- src/Actions/WorldAction/CenterInBoxAction.cpp	(revision de29ad6ec3f6c4826f398de6a82efb8324c26e79)
+++ src/Actions/WorldAction/CenterInBoxAction.cpp	(revision 68c92366449b96cba16e719bf1bc16ca92f66370)
@@ -53,5 +53,5 @@
   std::stringstream undostream;
   boost::archive::text_oarchive oa(undostream);
-  RealSpaceMatrix matrix(World::getInstance().getDomain().getM());
+  const RealSpaceMatrix &matrix = World::getInstance().getDomain().getM();
   oa << matrix;
   std::vector< boost::shared_ptr<Vector> > OldPositions;
Index: src/Box.cpp
===================================================================
--- src/Box.cpp	(revision de29ad6ec3f6c4826f398de6a82efb8324c26e79)
+++ src/Box.cpp	(revision 68c92366449b96cba16e719bf1bc16ca92f66370)
@@ -120,4 +120,5 @@
     default:
       ASSERT(0,"No default case for this");
+      break;
     }
 
Index: src/Graph/BondGraph.hpp
===================================================================
--- src/Graph/BondGraph.hpp	(revision de29ad6ec3f6c4826f398de6a82efb8324c26e79)
+++ src/Graph/BondGraph.hpp	(revision 68c92366449b96cba16e719bf1bc16ca92f66370)
@@ -199,5 +199,4 @@
     };
     // skip headers
-    unsigned int bondcount = 0;
     for (unsigned int i=0;i<skiplines;i++)
       input->getline(line,MAXSTRINGSIZE);
Index: src/IPointCloud.hpp
===================================================================
--- src/IPointCloud.hpp	(revision de29ad6ec3f6c4826f398de6a82efb8324c26e79)
+++ src/IPointCloud.hpp	(revision 68c92366449b96cba16e719bf1bc16ca92f66370)
@@ -14,6 +14,5 @@
 #endif
 
-
-#include <cstdio>
+#include <string>
 
 class TesselPoint;
@@ -22,5 +21,5 @@
 /** Encapsulates a set of TesselPoints with an internal iterator.
  */
-class IPointCloud {
+struct IPointCloud {
 public:
   virtual const std::string& GetName() const=0;
Index: src/Parser/ChangeTracker.hpp
===================================================================
--- src/Parser/ChangeTracker.hpp	(revision de29ad6ec3f6c4826f398de6a82efb8324c26e79)
+++ src/Parser/ChangeTracker.hpp	(revision 68c92366449b96cba16e719bf1bc16ca92f66370)
@@ -41,5 +41,5 @@
   // private constructor and destructor due to singleton
   ChangeTracker();
-  ~ChangeTracker();
+  virtual ~ChangeTracker();
 };
 
Index: src/Tesselation/BoundaryTriangleSet.cpp
===================================================================
--- src/Tesselation/BoundaryTriangleSet.cpp	(revision de29ad6ec3f6c4826f398de6a82efb8324c26e79)
+++ src/Tesselation/BoundaryTriangleSet.cpp	(revision 68c92366449b96cba16e719bf1bc16ca92f66370)
@@ -192,6 +192,7 @@
     return false;
   }
-}
-;
+  return true;
+}
+
 
 /** Finds the point on the triangle to the point \a *x.
Index: src/UIElements/Menu/TextMenu/ActionMenuItem.hpp
===================================================================
--- src/UIElements/Menu/TextMenu/ActionMenuItem.hpp	(revision de29ad6ec3f6c4826f398de6a82efb8324c26e79)
+++ src/UIElements/Menu/TextMenu/ActionMenuItem.hpp	(revision 68c92366449b96cba16e719bf1bc16ca92f66370)
@@ -30,5 +30,5 @@
 public:
   ActionMenuItem(char,const std::string &,TxMenu* const,const std::string &);
-  ~ActionMenuItem();
+  virtual ~ActionMenuItem();
 
   virtual void doTrigger();
Index: src/UIElements/Menu/TextMenu/TextMenu.hpp
===================================================================
--- src/UIElements/Menu/TextMenu/TextMenu.hpp	(revision de29ad6ec3f6c4826f398de6a82efb8324c26e79)
+++ src/UIElements/Menu/TextMenu/TextMenu.hpp	(revision 68c92366449b96cba16e719bf1bc16ca92f66370)
@@ -66,5 +66,5 @@
    *
    */
-  ~TextMenu()
+  virtual ~TextMenu()
   {
     ShortcutMap.clear();