Index: molecuilder/src/builder.cpp
===================================================================
--- molecuilder/src/builder.cpp	(revision 44fa6a1401b64d07b5cb619358e9b6a83e324974)
+++ molecuilder/src/builder.cpp	(revision 71dc4ed5898d29c5c1317112e75b4a0b0747a162)
@@ -931,5 +931,5 @@
                 cout << Verbose(0) << "Creating connection matrix..." << endl;
                 start = clock();
-                mol->CreateAdjacencyList((ofstream *)&cout, atof(argv[argptr++]));
+                mol->CreateAdjacencyList((ofstream *)&cout, atof(argv[argptr++]), configuration.GetIsAngstroem());
                 cout << Verbose(0) << "Fragmenting molecule with current connection matrix ..." << endl;
                 if (mol->first->next != mol->last) {
@@ -1116,5 +1116,5 @@
           }
           if (mol->first->next != mol->last) // if connect matrix is present already, redo it
-            mol->CreateAdjacencyList((ofstream *)&cout, mol->BondDistance);
+            mol->CreateAdjacencyList((ofstream *)&cout, mol->BondDistance, configuration.GetIsAngstroem());
           // free memory
           delete[](Elements);
@@ -1159,5 +1159,5 @@
         cin >> tmp1;
         start = clock();
-        mol->CreateAdjacencyList((ofstream *)&cout, tmp1);
+        mol->CreateAdjacencyList((ofstream *)&cout, tmp1, configuration.GetIsAngstroem());
         //mol->CreateListOfBondsPerAtom((ofstream *)&cout);
         Subgraphs = mol->DepthFirstSearchAnalysis((ofstream *)&cout, false, MinimumRingSize);
Index: molecuilder/src/molecules.cpp
===================================================================
--- molecuilder/src/molecules.cpp	(revision 44fa6a1401b64d07b5cb619358e9b6a83e324974)
+++ molecuilder/src/molecules.cpp	(revision 71dc4ed5898d29c5c1317112e75b4a0b0747a162)
@@ -1318,6 +1318,7 @@
  * \param *out out stream for printing the matrix, NULL if no output
  * \param bonddistance length of linked cells (i.e. maximum minimal length checked)
- */
-void molecule::CreateAdjacencyList(ofstream *out, double bonddistance)
+ * \param IsAngstroem whether coordinate system is gauged to Angstroem or Bohr radii
+ */
+void molecule::CreateAdjacencyList(ofstream *out, double bonddistance, bool IsAngstroem)
 {
   atom *Walker = NULL, *OtherWalker = NULL;
@@ -1329,5 +1330,5 @@
   vector x;
  
-  BondDistance = bonddistance;
+  BondDistance = bonddistance; // * ((IsAngstroem) ? 1. : 1./AtomicLengthToAngstroem);
   *out << Verbose(0) << "Begin of CreateAdjacencyList." << endl;
   // remove every bond from the list
@@ -1407,5 +1408,6 @@
                         /// \todo periodic check is missing here!
                         //*out << Verbose(1) << "Checking distance " << OtherWalker->x.PeriodicDistance(&(Walker->x), cell_size) << " against typical bond length of " << bonddistance*bonddistance << "." << endl;
-                        MinDistance = OtherWalker->type->CovalentRadius + Walker->type->CovalentRadius;  
+                        MinDistance = OtherWalker->type->CovalentRadius + Walker->type->CovalentRadius;
+                        MinDistance *= (IsAngstroem) ? 1. : 1./AtomicLengthToAngstroem;
                         MaxDistance = MinDistance + BONDTHRESHOLD;
                         MinDistance -= BONDTHRESHOLD;
@@ -1414,4 +1416,5 @@
                           *out << Verbose(0) << "Adding Bond between " << *Walker << " and " << *OtherWalker << "." << endl;
                           AddBond(Walker->father, OtherWalker->father, 1);  // also increases molecule::BondCount
+                          BondCount++;
                         } else {
                           //*out << Verbose(1) << "Not Adding: Wrong label order or distance too great." << endl;
@@ -1428,6 +1431,6 @@
         delete(CellList[i]);
       }
-    Free((void **)&CellList, "molecule::CreateAdjacencyList - ** CellList"); 
-  
+    Free((void **)&CellList, "molecule::CreateAdjacencyList - ** CellList");
+    
     // create the adjacency list per atom
     CreateListOfBondsPerAtom(out);
Index: molecuilder/src/molecules.hpp
===================================================================
--- molecuilder/src/molecules.hpp	(revision 44fa6a1401b64d07b5cb619358e9b6a83e324974)
+++ molecuilder/src/molecules.hpp	(revision 71dc4ed5898d29c5c1317112e75b4a0b0747a162)
@@ -279,5 +279,5 @@
 
   /// Initialising routines in fragmentation  
-  void CreateAdjacencyList(ofstream *out, double bonddistance);
+  void CreateAdjacencyList(ofstream *out, double bonddistance, bool IsAngstroem);
   void CreateListOfBondsPerAtom(ofstream *out);
   