Index: src/Potentials/Specifics/unittests/PairPotential_MorseUnitTest.cpp
===================================================================
--- src/Potentials/Specifics/unittests/PairPotential_MorseUnitTest.cpp	(revision 76cbd082753cf16eee92e72dd98df9644cb2bd3f)
+++ src/Potentials/Specifics/unittests/PairPotential_MorseUnitTest.cpp	(revision 76cbd082753cf16eee92e72dd98df9644cb2bd3f)
@@ -0,0 +1,183 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2012 University of Bonn. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * PairPotential_MorseUnitTest.cpp
+ *
+ *  Created on: Oct 04, 2012
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+using namespace std;
+
+#include <cppunit/CompilerOutputter.h>
+#include <cppunit/extensions/TestFactoryRegistry.h>
+#include <cppunit/ui/text/TestRunner.h>
+
+#include "PairPotential_MorseUnitTest.hpp"
+
+#include <boost/assign.hpp>
+
+#include "CodePatterns/Assert.hpp"
+
+#include "FunctionApproximation/FunctionArgument.hpp"
+#include "Potentials/Specifics/PairPotential_Morse.hpp"
+#include "Potentials/helpers.hpp"
+
+using namespace boost::assign;
+
+#ifdef HAVE_TESTRUNNER
+#include "UnitTestMain.hpp"
+#endif /*HAVE_TESTRUNNER*/
+
+/********************************************** Test classes **************************************/
+
+// Registers the fixture into the 'registry'
+CPPUNIT_TEST_SUITE_REGISTRATION( PairPotential_MorseTest );
+
+
+void PairPotential_MorseTest::setUp()
+{
+  // failing asserts should be thrown
+  ASSERT_DO(Assert::Throw);
+
+  // data is taken from gnuplot via set table "morse.dat" with
+  // g(x)=D*(1- exp(-a*(x-c)))**2+d
+  a = 0.897888;
+  c = 2.92953;
+  d = -78.9883;
+  D = 0.196289;
+  input +=
+      1.89012,
+      2.17632,
+      2.46253,
+      2.74873,
+      3.03493,
+      3.32114,
+      3.60734,
+      3.89354,
+      4.17974,
+      4.46595;
+  output +=
+      -78.5211,
+      -78.8049,
+      -78.935,
+      -78.9822,
+      -78.9867,
+      -78.971,
+      -78.9475,
+      -78.9225,
+      -78.899,
+      -78.8784;
+
+  CPPUNIT_ASSERT_EQUAL( input.size(), output.size() );
+}
+
+
+void PairPotential_MorseTest::tearDown()
+{
+}
+
+/** UnitTest for operator()
+ */
+void PairPotential_MorseTest::operatorTest()
+{
+  PairPotential_Morse Morse(a,c,D,d);
+  for (size_t index = 0; index < input.size(); ++index) {
+    CPPUNIT_ASSERT(
+        Helpers::isEqual(
+            output[index],
+            Morse( FunctionModel::arguments_t(1,argument_t(input[index])) )[0],
+            1.e-4/std::numeric_limits<double>::epsilon() // only compare four digits
+        )
+    );
+  }
+}
+
+/** UnitTest for derivative()
+ */
+void PairPotential_MorseTest::derivativeTest()
+{
+  PairPotential_Morse Morse(a,c,D,d);
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          0.,
+          Morse.derivative(
+              FunctionModel::arguments_t(1,argument_t(c))
+          )[0],
+          1.e+6
+      )
+  );
+}
+
+
+/** UnitTest for parameter_derivative()
+ */
+void PairPotential_MorseTest::parameter_derivativeTest()
+{
+  PairPotential_Morse Morse(a,c,D,d);
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          0.,
+          Morse.parameter_derivative(
+              FunctionModel::arguments_t(1,argument_t(c)),
+              0
+          )[0],
+          1.e+6
+      )
+  );
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          0.,
+          Morse.parameter_derivative(
+              FunctionModel::arguments_t(1,argument_t(c)),
+              1
+          )[0],
+          1.e+6
+      )
+  );
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          0.,
+          Morse.parameter_derivative(
+              FunctionModel::arguments_t(1,argument_t(c)),
+              2
+          )[0],
+          1.e+6
+      )
+  );
+  CPPUNIT_ASSERT(
+      Helpers::isEqual(
+          1.,
+          Morse.parameter_derivative(
+              FunctionModel::arguments_t(1,argument_t(c)),
+              3
+          )[0],
+          1.e+6
+      )
+  );
+}